import javax.swing.*;
import java.rmi.*;
import java.rmi.server.*;
import java.util.*;

public class Bingo extends java.rmi.server.UnicastRemoteObject implements BingoInterface {

    public Bingo() throws RemoteException {
		joueurs = new Vector();
		tirages = new Vector();
		
		joueurs_model = new DefaultListModel();
		joueurs_list = new JList(joueurs_model);
		joueurs_list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		joueurs_list.setFixedCellWidth(170);
		joueurs_scrollpane = new JScrollPane(joueurs_list);
		joueurs_list.setEnabled(false);
		joueurs_model.addElement("Aucun joueur");
	
		tirages_model = new DefaultListModel();
		tirages_list = new JList(tirages_model);
		tirages_list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		tirages_list.setFixedCellWidth(170);
		tirages_scrollpane = new JScrollPane(tirages_list);
		tirages_list.setEnabled(false);
		tirages_model.addElement("Aucun numro");

		supprimerButton = new JButton("Supprimer ce joueur");
		supprimerButton.setEnabled(false);
		
		demarrerButton = new JButton("Dmarrer la partie");
		demarrerButton.setEnabled(false);
	
		terminerButton = new JButton("Terminer la partie");
		terminerButton.setEnabled(false);

		tirageButton = new JButton("Effectuer un tirage");
		tirageButton.setEnabled(false);

		JTFpret = new JTextField("Aucun joueur selectionn",15);
		JTFpret.setEditable(false);
		
		JTFtirages = new JTextField("0",3);
		JTFtirages.setEditable(false);
    }

    //Obtention d'une grille
    public int [] getGrille(String name,boolean nouveau) throws RemoteException {
    	
     	int [] r = new int[27];
    	
    	//initialisation du tableau
    	//Arrays.fill(r,-1); //marche pas  la fac!
		for (int i=0;i<27;i++) r[i]=-1;
    	
	   	//on vrifie si le joueur est dj inscrit, 
	   	Joueur jcourant;
    	boolean trouve = false;
    	recherche :
	    for (int i=0;i<joueurs.size();i++) {
		jcourant = (Joueur) joueurs.get(i);
    		if (name.equals(jcourant.getnom())) {
			    //dj inscrit
			    trouve=true;
			    //c'est qu'il y a quelquechose qui cloche : deux clients ont le mme nom
			    if (nouveau) {
					return r;
				}
			    jcourant.setgrille(r);
			    break recherche;
    		}
	    }
    	//sinon inscription
    	if (!trouve) {
    	JOptionPane.showMessageDialog(null,"2");
		    jcourant = new Joueur(name);
		    jcourant.setgrille(r);
		    joueurs.add(jcourant);
		    joueurs_model.removeElement("Aucun joueur");
		    joueurs_list.setEnabled(true);
		    if (joueurs.size()==1) joueurs_model.addElement("Liste des joueurs :");
		    joueurs_model.addElement(name);
    	}
    	
    	//remplissage des 12 cases "noires"
		int indice;
    	for (int i=0;i<12;i++) {
	    do {
			indice = (int)(Math.random()*27);
	    } while (r[indice]==0);
	    	r[indice] = 0;
    	}
    	
    	//remplissage des autres cases avec des nombres
    	int random = 0;
    	for (int i=0;i<27;i++) {
	   	 	//on vrifie qu'on est sur une case  remplir
		    if (r[i]!=0) {
			//boucle pour vrifier que le numro n'est pas dj allou
			do {
			    random=(int)(Math.random()*90+1);
			    //un petit label bien pratique
			    verification_unicit:
			    for (int j=0;j<27;j++) {
					if (r[j]==random) {
					    random=0;
					    break verification_unicit;
					}
			    }
			}
			while (random==0);
			r[i]=random;
		    }
    	}
    	
    	return r;
    }
    
    //Le joueur "name" avertit qu'il est pret
    public void pret(String name) throws RemoteException {
    	demarrerButton.setEnabled(true);
    	Joueur jcourant;
    	recherche:
    	for (int i=0;i<joueurs.size();i++) {
    		jcourant = (Joueur) joueurs.get(i);
			if (name.equals(jcourant.getnom())) {
				jcourant.setpret(true);
				break recherche;
			}
		}
	
    }    	
    
    //primitive ddie au serveur pour qu'il tire un numro
    public void tirage() {
    	if (tirages.size()==90) {
    		//la partie est termine
	    	JOptionPane.showMessageDialog(null,"C'est fini, tous les numros sont sortis");
	    	terminerButton.setEnabled(true);
    	} else {
	    	int random;
	    	//on fait attention  ne pas tirer un numros dj tir
	    	do {
	    		random = (int)(Math.random()*90+1);
	    		tirage_unique:
	    		for (int i=0;i<tirages.size();i++)
	    			if (((Integer)tirages.get(i)).intValue()==random) {
	    				random=0;
	    				break tirage_unique;
	    			}
	    	} while (random==0);
	    	//ajout du numro dans la liste d'affichage
	    	tirages_model.removeElement("Aucun numro");
	    	tirages_model.addElement(Integer.toString(random));
	    	//ajout du numro dans le veteur
	    	tirages.add(new Integer(random));
	    	//incrmentation du compteur
	    	JTFtirages.setText( Integer.toString(tirages.size()) );
	    }
    }
    
    //termine la partie : tout le monde part
    public void termine() {
    	int nb=joueurs.size();
    	for (int i=0;i<nb;i++) {
    		joueurs_model.removeElement( ((Joueur)joueurs.get(0)).getnom() );
    		joueurs.remove(0);
    	}
    	nb=tirages.size();
    	for (int i=0;i<nb;i++) {
    		tirages_model.removeElement(Integer.toString( ((Integer)tirages.get(0)).intValue() ));
    		tirages.remove(0);
    	}
    	//on supprime toujours l'lment avant de l'ajouter pour tre sr qu'il n'y sera qu'une fois
	    joueurs_model.removeElement("Liste des joueurs :");
		joueurs_model.removeElement("Aucun joueur");
		joueurs_model.addElement("Aucun joueur");
    	tirages_model.removeElement("Aucun numro");
    	tirages_model.addElement("Aucun numro");
    	JTFtirages.setText("0");
    	joueurs_list.setEnabled(false);
	  	demarrerButton.setEnabled(false);
		tirageButton.setEnabled(false);
    	tirageItem.setEnabled(false);
    }
    
    //Consultation des tirages effectus lors de la partie courante
    //on ne renvoit que les tirages dont le joueur n'est pas inform
    public Vector getTirage(int nb,String name) throws RemoteException {
		Vector v = new Vector();
		for (int i=nb;i<tirages.size();i++) v.add(tirages.get(i));
    	return v;
    }

    //suppression d'un joueur : il quitte la partie
    public void bye(String name) throws RemoteException {
		byeServer(name);
    }
    
    //le serveur supprime un joueur
    public void byeServer(String name) {
    	//on teste d'abord que la liste n'a pas dj t vide (par le serveur par exemple)
		if (joueurs.size()!=0) {
			Joueur jcourant;
			joueurs_model.removeElement(name);
			for (int i=0;i<joueurs.size();i++) {
			    jcourant = (Joueur) joueurs.get(i);
			    if (name.equals(jcourant.getnom())) joueurs.remove(i);    		
			}
			supprimerButton.setEnabled(false);
			//s'il n'y a plus de joueurs, la partie est finie
			if (joueurs.size()==0) termine();
		}
    }
    
    //permet de savoir si un joueur est pret
    public boolean getpret(String name) {
		Joueur jcourant;
		for (int i=0;i<joueurs.size();i++) {
		    jcourant = (Joueur) joueurs.get(i);
		    if (name.equals(jcourant.getnom())) return jcourant.getpret();
		}
		return false;
    }
    
    private Vector joueurs;
    private Vector tirages;
    public JMenuItem tirageItem;
    public JButton demarrerButton;
    public JButton tirageButton;
    public JButton supprimerButton;
	public JButton terminerButton;
	private DefaultListModel joueurs_model;	//ncessaire pour
	public JList joueurs_list;				//afficher la liste
	public JScrollPane joueurs_scrollpane;	//des joueurs
	private DefaultListModel tirages_model;	//ncessaire pour
	private JList tirages_list;				//afficher la liste
	public JScrollPane tirages_scrollpane;	//des numros tirs
	public JTextField JTFpret;				//affiche si le joueur selectionn est prt
	public JTextField JTFtirages;			//affichage du nombre de tirages
}

//Pour stocker les informations sur les joueurs
class Joueur {
	
    public Joueur(String n) {
		nom = n;	
		pret = false;
    }
	
    public void setgrille(int [] g) {
		System.arraycopy(g,0,grille,0,27);	
    }
	
    public String getnom() {
		return nom;
    }
	
	public void setpret(boolean p) {
		pret=p;
	}
	
	public boolean getpret() {
		return pret;
	}
	
	private boolean pret;
    private String nom;
    private int [] grille = new int [27];	
}
