import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import BingoInterface.*;
import java.rmi.*;
import java.util.*;
 
///////////////////////////////////////////////
//	FRAME PRINCIPALE
///////////////////////////////////////////////
class BingoClientFrame extends JFrame implements ActionListener {
	
    public BingoClientFrame() {
		setTitle("Bingo");
		setSize(500,300);
		setLocation(200,200);
		addWindowListener(new WindowAdapter() {  
			public void windowClosing(WindowEvent e) {
				//deconnexion lors de la fermeture de la fentre 
					if (deconnecterButton.isEnabled()) try {
		    				bingo.bye(nom);
						} catch (Exception ex) {
		    				System.out.println("BingoClient exception : " + ex);
						} 
					System.exit(0); 
				}
		    });
		    
		nom = new String();	
		setNom();
		nouveau=true;
		
		//cration des menus	
		JMenuBar mbar = new JMenuBar();
		setJMenuBar(mbar);
			
		JMenu fileMenu = new JMenu("File");
		mbar.add(fileMenu);
			
		tirageItem = new JMenuItem("Tirage");
		tirageItem.setEnabled(false);
		tirageItem.addActionListener(this);
		fileMenu.add(tirageItem);
			
		nouvellegrilleItem = new JMenuItem("Nouvelle grille");
		nouvellegrilleItem.setEnabled(false);
		nouvellegrilleItem.addActionListener(this);
		fileMenu.add(nouvellegrilleItem);
			
		infoItem = new JMenuItem("Informations");
		infoItem.addActionListener(this);
		fileMenu.add(infoItem);
					
		aboutItem = new JMenuItem("About");
		aboutItem.addActionListener(this);
		fileMenu.add(aboutItem);
			
		exitItem = new JMenuItem("Exit");
		exitItem.addActionListener(this);
		fileMenu.add(exitItem);
			
		JMenu connectMenu = new JMenu("Se connecter");
		mbar.add(connectMenu);
			
		localItem = new JMenuItem("local");
		localItem.addActionListener(this);
		connectMenu.add(localItem);
					
		scisrvItem = new JMenuItem("scisrv.univ-bpclermont.fr");
		scisrvItem.addActionListener(this);
		connectMenu.add(scisrvItem);
			
		scioraItem = new JMenuItem("sciora.univ-bpclermont.fr");
		scioraItem.addActionListener(this);
		connectMenu.add(scioraItem);
		
		//Panel principal
		Container contentPane = getContentPane();
		
		GridBagLayout grid = new GridBagLayout();
		contentPane.setLayout(grid);
		GridBagConstraints gbc = new GridBagConstraints();

		gbc.gridx=0;
		gbc.gridy=0;
		gbc.fill=GridBagConstraints.NONE;
		gbc.gridwidth=1;
		gbc.gridheight=1;
		gbc.weightx=0;
		gbc.weighty=0;
		gbc.anchor=GridBagConstraints.CENTER;		
		gbc.insets.top=10;
		gbc.insets.bottom=10;
		connecterButton = new JButton("Se connecter");
		contentPane.add(connecterButton,gbc);	
		connecterButton.addActionListener(this);
		
		gbc.gridx=1;
		gbc.gridy=0;
		gbc.insets.left=10;
		deconnecterButton = new JButton("Se dconnecter");
		deconnecterButton.addActionListener(this);
		deconnecterButton.setEnabled(false);
		contentPane.add(deconnecterButton,gbc);	

		gbc.gridx=2;
		gbc.gridy=0;
		gbc.insets.left=0;
		pretButton = new JButton("Prt");
		pretButton.addActionListener(this);
		pretButton.setEnabled(false);
		contentPane.add(pretButton,gbc);	
		BingoButton = new JButton("Bingo!");
		BingoButton.addActionListener(this);
		BingoButton.setVisible(false);
		BingoButton.setEnabled(false);
		contentPane.add(BingoButton,gbc);	
	
		
		gbc.gridx=0;
		gbc.gridy=1;
		gbc.fill=GridBagConstraints.BOTH;
		gbc.gridwidth=3;
		gbc.gridheight=1;
		gbc.weightx=100;
		gbc.weighty=100;		
		gbc.insets.bottom=0;
		gbc.insets.top=0;

		//grille de numros
		AffGrille = new GrillePanel();
		contentPane.add(AffGrille,gbc);
    }
    
    //permet  l'utilisateur de saisir son nom
    public void setNom() {
		nom = JOptionPane.showInputDialog(this,"Votre nom ?","Identification",JOptionPane.QUESTION_MESSAGE);
		if (nom==null) nom="";
		if (nom.equals("")) {
			nom="Guest";
			JOptionPane.showMessageDialog(null,"Tant pis!\n\nVotre nom est : "+nom);
		}

    }
    
    //permet  l'utilisateur d'entrer l'adresse du serveur
    public void connect() {
    	String adress="127.0.0.1";
    	adress = (String)JOptionPane.showInputDialog(this,"Entrez l'adresse du serveur distant :","Connection",JOptionPane.QUESTION_MESSAGE,null,null,adress);
    	if (adress!=null) connect(adress);
    }

    //connection au serveur
    public void connect(String adress) {
    	adress="rmi://"+adress+"/Bingo";
    	//quitte la connection prcdente : ne doit pas tre effectu tant que le
    	// joueur est nouveau
		if (!nouveau) bye();
		//activation des menus
		deconnecterButton.setEnabled(true);
		pretButton.setEnabled(true);
		nouvellegrilleItem.setEnabled(true);
		//connection et obtention d'une grille
		try {
		    bingo = (BingoInterface) Naming.lookup(adress);
    		getGrille();
			BingoButton.setEnabled(false);
			BingoButton.setVisible(false);
		    pretButton.setVisible(true);
		} catch (Exception e) {
		    reinit();
		} 
    }
 
    //obtention d'une grille
    public void getGrille() {
		try {
		    int [] grille = bingo.getGrille(nom,nouveau);
		    if (grille[0]==-1) {
		    	deconnecterButton.setEnabled(false);
				BingoButton.setEnabled(false);
				BingoButton.setVisible(false);
				pretButton.setEnabled(false);
				nouvellegrilleItem.setEnabled(false);
				tirageItem.setEnabled(false);
		    	JOptionPane.showMessageDialog(null,"Dsol, mais un autre joueur s'appelle dj "+nom);
		    	setNom();
		    } else {
		    	nouveau = false;
				AffGrille.maj(grille);
			}
		} catch (Exception e) {
		    reinit();
		} 
    }
 
 	//signale au serveur qu'on est pret
 	public void pret() {
		try {
		    bingo.pret(nom);
			BingoButton.setVisible(true);
		    pretButton.setVisible(false);
    		tirageItem.setEnabled(true);
		} catch (Exception e) {
		    reinit();
		} 
	}
 
 	//consulte les derniers tirages (tous ceux qu'ils ne connait pas)
 	public void consulte_tirage() {
		Vector v;
		try {
	 		v = bingo.getTirage(nbTiragesrecus,nom);
			if (v!=null) {
				if (v.size()==0) JOptionPane.showMessageDialog(null,"Aucun nouveau numro de tir!");
				nbTiragesrecus+=v.size();
				for (int i=0;i<v.size();i++) {
					AffGrille.marquer(((Integer)v.get(i)).intValue());
				}
			}
			if (AffGrille.nb_marquees()==15) BingoButton.setEnabled(true);
		} catch (Exception e) {
		    reinit();
		}
 	}
 
    //Deconnection du serveur
    public void bye() {
		deconnecterButton.setEnabled(false);
		pretButton.setEnabled(false);
		BingoButton.setEnabled(false);
		BingoButton.setVisible(false);
		nouvellegrilleItem.setEnabled(false);
		tirageItem.setEnabled(false);
		AffGrille.vide();
		try {
		    bingo.bye(nom);
		    pretButton.setVisible(true);
		} catch (Exception e) {
		    reinit();
		} 
    }	
 
 	//rinitialise l'application : lorsque la communication a t rompue.
 	public void reinit() {
    	JOptionPane.showMessageDialog(null,"Connexion avec l'hte perdue!");
		deconnecterButton.setEnabled(false);
		pretButton.setEnabled(false);
		BingoButton.setEnabled(false);
		BingoButton.setVisible(false);
		nouvellegrilleItem.setEnabled(false);
		tirageItem.setEnabled(false);
		AffGrille.vide();
	    pretButton.setVisible(true);
 	}
 
    //gestionnaire d'vnements
    public void actionPerformed(ActionEvent evt) {
		Object source = evt.getSource();
		if (source == nouvellegrilleItem) getGrille();
		else if (source == tirageItem) consulte_tirage();
		else if (source == localItem) connect("127.0.0.1");
		else if (source == scisrvItem) connect("scisrv.univ-bpclermont.fr");
		else if (source == scioraItem) connect("sciora.univ-bpclermont.fr");
		else if (source == aboutItem) {
		    if (dialog == null) dialog = new AboutDialog(this);   
		    dialog.show();
		}
		else if (source == exitItem) System.exit(0);
		else if (source == pretButton) pret();
		else if (source == deconnecterButton) bye();
		else if (source == connecterButton) connect();
		else if (source == infoItem) 
			if (deconnecterButton.isEnabled()) JOptionPane.showMessageDialog(null,"Votre nom est :\n"+nom+"\net vous tes actuellement connect.");
			else JOptionPane.showMessageDialog(null,"Votre nom est :\n"+nom+"\net vous n'tes pas connect actuellement.");
		else if (source == BingoButton) {
			JOptionPane.showMessageDialog(null,"Bravo, vous avez gagn (le droit de recommencer).");
			bye();
		}
  	}
  	
    private AboutDialog dialog;
    private JMenuItem nouvellegrilleItem;
    private JMenuItem infoItem;
    private JMenuItem tirageItem;
    private JMenuItem aboutItem;
    private JMenuItem exitItem;
    private JMenuItem localItem;
    private JMenuItem scisrvItem;
    private JMenuItem scioraItem;
    private JButton connecterButton;
    private JButton deconnecterButton;
    private JButton pretButton;
    private JButton BingoButton;
    private GrillePanel AffGrille;
    private BingoInterface bingo;
    private String nom;
    private boolean nouveau;		//permet au serveur de savoir si c'est sa premire connexion
    private int nbTiragesrecus = 0;
}

///////////////////////////////////////////////
//	CASE
// reprsente une case sur la grille
///////////////////////////////////////////////
class Case extends JPanel {
	
    public Case() {
		cochee = false;
		//cration d'une case avec bordure	
		Border bordure = BorderFactory.createEtchedBorder();
		Border titre = BorderFactory.createTitledBorder(bordure,"");
		setBorder(titre);
		valeur = new String("");
		setBackground(SystemColor.window);	
		repaint();
    }
	
    public void paintComponent(Graphics g) {
		super.paintComponent(g);
		if (!valeur.equals("0")) g.drawString(valeur,5,30);
    }
	
    //Marquage de la case
    public void marquer() {
		cochee = true;
		setBackground(SystemColor.orange);
		
		repaint();
    }
	
	public void demarquer() {
	    cochee = false;
	    setBackground(SystemColor.window);
	    repaint();
	}

    public int getvaleur() {
		return Integer.parseInt(valeur);
    }
	
    public void setvaleur(int num) {
		//gestion des cases "vides"
		if (num!=0) setBackground(SystemColor.window);
		else setBackground(Color.blue);
		//conversion int -> String
		valeur = Integer.toString(num);
		repaint();
    }

    public void setvaleur(String val) {
	valeur = val ;
    }

	public boolean getcochee() {
		return cochee;
	}
	
    private boolean cochee;
    private String valeur;
}


///////////////////////////////////////////////
//	GRILLEPANEL
// reprsente une grille
///////////////////////////////////////////////
class GrillePanel extends JPanel {
	
    public GrillePanel() {
    	//cration d'une grille
		setLayout(new BorderLayout());
		setLayout(new GridLayout(3,9));
		//remplissage
		for (int i=0;i<27;i++) {
			cases[i] = new Case();
			add(cases[i]);
		}
		repaint();
    }

    //mise  jour de la grille
    public void maj (int [] num) {
		for (int i=0; i<27; i++) {
		    cases[i].demarquer();
		    cases[i].setvaleur(num[i]);
		}
		repaint();
    }

    //Marquage d'une case de la grille
    public void marquer(int num) {
		if ((num>0) && (num<91))
		    for (int i=0;i<27;i++)
				if (cases[i].getvaleur()==num) cases[i].marquer();
    }

	//Nombre de cases marquees
	public int nb_marquees() {
		int nb = 0;
		for (int i=0;i<27;i++) if (cases[i].getcochee()) nb++;
		return nb;
	}

    //vide une grille
    public void vide() {
		for (int i=0;i<27;i++) {
		    cases[i].setvaleur("");
		    cases[i].demarquer();
		}
		repaint();
    }
	
    public void paintComponent(Graphics g) {
		super.paintComponent(g);
    }
	
    private Case [] cases = new Case[27];
}

///////////////////////////////////////////////
//	ABOUT
///////////////////////////////////////////////
class AboutDialog extends JDialog {
    public AboutDialog(JFrame parent) {
	super(parent, "About Bingo", true);         
	
	Box b = Box.createVerticalBox();  //agencement vertical de la box
	b.add(Box.createGlue());          //sert  espacer les lments graphiquement
	b.add(new JLabel("Bingo"));
	b.add(new JLabel("Par Nicolas Dumoulin"));
	b.add(Box.createGlue());
	getContentPane().add(b, "Center");
	                
	JPanel p2 = new JPanel();
	JButton ok = new JButton("Ok");
	p2.add(ok);
	getContentPane().add(p2, "South");
	
	ok.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent evt) { setVisible(false); } 
	    });
	
	setSize(250, 150);
    }
}

public class BingoClient {
    public static void main(String[] args) {
		JFrame f = new BingoClientFrame();
		f.show();
	}
}
