import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import BingoInterface.*;
import Bingo.*;
import java.rmi.*;
import java.io.*;

///////////////////////////////////////////////
//	FRAME PRINCIPALE
///////////////////////////////////////////////
class BingoServerFrame extends JFrame implements ActionListener,ListSelectionListener,FocusListener {
	
    public BingoServerFrame() {
    	//Initialisation RMI
		System.setSecurityManager(new RMISecurityManager());
		try {
			b = new Bingo();
		    Naming.rebind("Bingo",b);
		    System.out.println("Serveur pret.");
		} catch (Exception e) {
		    System.out.println("Erreur serveur : " + e);
		}

		setTitle("Bingo");
		setSize(400,400);
		setLocation(200,200);
		addWindowListener(new WindowAdapter() {  
			public void windowClosing(WindowEvent e) {  System.exit(0); }
		    });
			
		//cration des menus	
		JMenuBar mbar = new JMenuBar();
		setJMenuBar(mbar);
			
		JMenu fileMenu = new JMenu("File");
		mbar.add(fileMenu);
			
		b.tirageItem = new JMenuItem("Tirage");
		b.tirageItem.setEnabled(false);
		b.tirageItem.addActionListener(this);
		fileMenu.add(b.tirageItem);
					
		aboutItem = new JMenuItem("About");
		aboutItem.addActionListener(this);
		fileMenu.add(aboutItem);
			
		exitItem = new JMenuItem("Exit");
		exitItem.addActionListener(this);
		fileMenu.add(exitItem);
		
		//Panel principal
		Container contentPane = getContentPane();
		
		GridBagLayout grid = new GridBagLayout();
		contentPane.setLayout(grid);
		GridBagConstraints gbc = new GridBagConstraints();

		gbc.fill=GridBagConstraints.NONE;
		gbc.weightx=50;
		gbc.weighty=0;
		gbc.anchor=GridBagConstraints.CENTER;		

		add(b.supprimerButton,gbc,1,0,1,1);	
		gbc.insets.top=10;
		add(b.JTFpret,gbc,1,1,1,1);
		gbc.insets.top=0;
		add(b.demarrerButton,gbc,1,2,1,1);	
		add(b.tirageButton,gbc,1,3,1,1);	
		add(b.JTFtirages,gbc,1,4,1,1);	
		add(b.terminerButton,gbc,1,5,1,1);
		gbc.fill=GridBagConstraints.VERTICAL;
		gbc.anchor=GridBagConstraints.WEST;		
		gbc.weightx=50;
		gbc.weighty=0;
		add(b.joueurs_scrollpane,gbc,0,0,1,3);

		gbc.weightx=50;
		gbc.weighty=0;
		add(b.tirages_scrollpane,gbc,0,3,1,2);

		b.supprimerButton.addActionListener(this);
		b.demarrerButton.addActionListener(this);
		b.terminerButton.addActionListener(this);
		b.tirageButton.addActionListener(this);
		b.joueurs_list.addListSelectionListener(this);

    }

	//routine pour ajuster un lment d'un GridBagLayout
	private void add(Component c,GridBagConstraints gbc,int x,int y,int w,int h) {
		gbc.gridx=x;
		gbc.gridy=y;
		gbc.gridwidth=w;
		gbc.gridheight=h;
		getContentPane().add(c,gbc);
	}

	public void demarrer() {
		b.tirageButton.setEnabled(true);
		b.tirageItem.setEnabled(true);
	}
	
    //gestionnaire d'vnements
    public void actionPerformed(ActionEvent evt) {
		Object source = evt.getSource();
		b.JTFpret.setText("Aucun joueur selectionn");
		if (source == b.tirageItem) ;
		else if (source == aboutItem) {
		    if (dialog == null) dialog = new AboutDialog(this);   
		    dialog.show();
		}
		else if (source == exitItem) System.exit(0);
		else if (source == b.demarrerButton) demarrer();
		else if (source == b.tirageButton) b.tirage();
		else if (source == b.supprimerButton) b.byeServer( (String)b.joueurs_list.getSelectedValue() );
		else if (source == b.terminerButton) b.termine();
    }
   
   	public void valueChanged(ListSelectionEvent evt) {
   		JList source = (JList)evt.getSource();
   		if (source.getSelectedValue()==null) {
   			b.JTFpret.setText("Aucun joueur selectionn");
   			b.supprimerButton.setEnabled(false);
   		}
   		else if ( ((String)source.getSelectedValue()).equals("Liste des joueurs :") ) {
   			b.JTFpret.setText("Aucun joueur selectionn");
   			b.supprimerButton.setEnabled(false);
   		}   		
   		else {
   			b.supprimerButton.setEnabled(true);
   			String nom = (String)source.getSelectedValue();
   			if (b.getpret(nom)) b.JTFpret.setText(nom+" est prt!");
   			else b.JTFpret.setText(nom+" n'est pas prt!");
   		}
   	}
   	
   	public void focusGained(FocusEvent evt) {
   		//rien pour l'instant
   	}
   	
   	public void focusLost(FocusEvent evt) {
   		if (evt.getComponent() == b.JTFpret) {
   			b.JTFpret.setText("Aucun joueur selectionn");
	   		b.supprimerButton.setEnabled(false);
		}
   	}
   	   	
   
   	private Bingo b;
    private AboutDialog dialog;
    private JMenuItem aboutItem;
    private JMenuItem exitItem;
}


public class BingoServer {
    
    public static void main (String [] argv) {
			JFrame f = new BingoServerFrame();
			f.show();
    }
}
